#!/usr/bin/env python
# coding: utf-8

# # Croissance de GaAs par épitaxie
# 
# 
# ## 1. Evolution temporelle de la concentration en AsH3 , CA(t) 
# 
# Compléter le script Python permettant de tracer les variations de CA en fonction du temps en utilisant la méthode d'Euler . 
# Le tracé se fera sur le même graphe que celui obtenu pour le tracé de la fonction dont l'expression est obtenue par résolution analytique .
# L'intervalle de temps à considérer est 0 < t < 0.1 s . 
# La liste des temps sera notée date , celle des valeurs de la concentration de AsH3 sera notée Concentrations.

# In[ ]:


import numpy as np
import matplotlib.pyplot as plt

#1ère partie : Evolution temporelle de [AsH3]= CA  
#Données
CA0= 1                 #concentration initiale en AsH3    mol/L
kd1 = 0.01             # constante de vitesse à T = 580K
Ea= 184                # energie d'activation en kJ/mol
R=8.314                #constante des gaz parfaits J/K/mol

#Calcul de kd à T = 750
kd2 = 
print("valeur de kd à 750K =",kd2,"s-1")

# Détermination de CA(t) à 750 K  et tracé
# 1) Méthode D'Euler





# 2) Fonction odeint
from scipy.integrate import odeint
n=200       #nombre de valeurs de la variable t dans l'intervalle retenu
T=np.linspace ( 0, 0.1 ,n)
def F(CA,t):
    return (-kd2*CA)
solCA = odeint ( F, [CA0],T)

# 3) réolution analytique
def CA3(t):
    
CAan=CA3(T)

plt.figure(0)
plt.plot(date,Concentrations,'xk',label='CA(t) Euler')  # date est la liste des temps  et Concentrations celle des valeurs de CA renvoyées par Euler
plt.plot(T,solCA,'ob',label='CA(t)')
plt.plot(T,CAan,'+ r',label='CA(T) analytique')
plt.legend()
plt.xlabel("t(s)")
plt.ylabel ("CA(mol/l)")
plt.show()


# ## 2. Epaisseur et taux de croissance 
# Résoudre le système d'équations différentielles associées aux fonctions CT(t) , CM(t) et e(t)  en utilisant la fonction odeint . 
# Tracer le graphe montrant l'écolution de l'épaisseur au cours du temps . 
# L'intervalle des  temps à considérer ici est  [0 , 500s ]

# In[ ]:


#Données
CT0= 0.01                  #concentration initiale en Ga(CH3)3   mol/L
CM0=0                     #concentration initiale en  Ga(CH3)    mol/L
k1 = 5e-2                  # constante de vitesse à T = 580K
k2 =5e-4                   # energie d'activation en kJ/mol
alpha=10**4
mv= 5.3e6                 # masse volumique  en g/m3
M= 145                    #masse molaire de GaAs en g/mol

n=200       #nombre de valeurs de la variable t dans l'intervalle retenu
T2=np.linspace ( 0,500 ,n)

# Système d'équations différentielles 






plt.figure(1)
plt.plot(T2,e,'xr',label='épaisseur')
plt.legend()
plt.xlabel("t(s)")
plt.ylabel ("e(m)")
plt.show()


# ## 3.Taux de croissance 
# 
# Tracer le graphe montrant l'évolution du taux de croissance en fonction du temps .

# In[ ]:


def tau.........




plt.figure(2)
plt.plot(T2,Y,'xg',label='taux de croissance')
plt.legend()
plt.xlabel("t(s)")
plt.ylabel ("de/dt")
plt.show()


# ## 4. temps pour lequel le taux de croissance est maximal , tmax
# 
# Faire afficher sur le script Python la valeur tmax obtenue à partir de la résolution analytique  . 
# Cette valeur peut être déterminée  en utilisant la fonction argmax . 
# Regarder l'influence du nombre n de valeurs choisi pour la variable t .
# 

# In[ ]:


#résolution analytique
tmax = 
print ("tmax analytique = ",tmax,"s")


# utilisation du code précédent 
print ("tmax numérique=",T2[np.argmax(Y)],"s")

